// Code generated by mockery v2.53.0. DO NOT EDIT.

package db

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	models "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/internal/models"
)

// MockThreads is an autogenerated mock type for the Threads type
type MockThreads struct {
	mock.Mock
}

// CreateThread provides a mock function with given fields: ctx, thread
func (_m *MockThreads) CreateThread(ctx context.Context, thread *models.Thread) (*models.Thread, error) {
	ret := _m.Called(ctx, thread)

	if len(ret) == 0 {
		panic("no return value specified for CreateThread")
	}

	var r0 *models.Thread
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.Thread) (*models.Thread, error)); ok {
		return rf(ctx, thread)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.Thread) *models.Thread); ok {
		r0 = rf(ctx, thread)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Thread)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.Thread) error); ok {
		r1 = rf(ctx, thread)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteThread provides a mock function with given fields: ctx, thread
func (_m *MockThreads) DeleteThread(ctx context.Context, thread *models.Thread) error {
	ret := _m.Called(ctx, thread)

	if len(ret) == 0 {
		panic("no return value specified for DeleteThread")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.Thread) error); ok {
		r0 = rf(ctx, thread)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetThreadByID provides a mock function with given fields: ctx, id
func (_m *MockThreads) GetThreadByID(ctx context.Context, id string) (*models.Thread, error) {
	ret := _m.Called(ctx, id)

	if len(ret) == 0 {
		panic("no return value specified for GetThreadByID")
	}

	var r0 *models.Thread
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.Thread, error)); ok {
		return rf(ctx, id)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.Thread); ok {
		r0 = rf(ctx, id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Thread)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetThreadByPRN provides a mock function with given fields: ctx, prn
func (_m *MockThreads) GetThreadByPRN(ctx context.Context, prn string) (*models.Thread, error) {
	ret := _m.Called(ctx, prn)

	if len(ret) == 0 {
		panic("no return value specified for GetThreadByPRN")
	}

	var r0 *models.Thread
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.Thread, error)); ok {
		return rf(ctx, prn)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.Thread); ok {
		r0 = rf(ctx, prn)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Thread)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, prn)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetThreads provides a mock function with given fields: ctx, input
func (_m *MockThreads) GetThreads(ctx context.Context, input *GetThreadsInput) (*ThreadsResult, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for GetThreads")
	}

	var r0 *ThreadsResult
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *GetThreadsInput) (*ThreadsResult, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *GetThreadsInput) *ThreadsResult); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*ThreadsResult)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *GetThreadsInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// NewMockThreads creates a new instance of MockThreads. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockThreads(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockThreads {
	mock := &MockThreads{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
